#!/usr/bin/env python
# coding: utf-8

import os
import numpy as np

from glob import glob
from netCDF4 import Dataset


def main(root='.'):

    root = '/scratch/snx1600/gkuhl/smartcarb/mother/2015010100_0_72/int2lm'

    inp_filenames = os.path.join(root, 'input', 'emissions', 'emis_*.nc')
    #inp_filenames = os.path.join(root, 'emissions_old', '*.nc')
    print(inp_filenames)
    inp_filenames = sorted(glob(inp_filenames))

    out_filenames = os.path.join(root, 'output', 'lbfd*e.nc')
    #out_filenames = os.path.join(root, 'emissions', '*.nc')
    print(out_filenames)
    out_filenames = sorted(glob(out_filenames))

    print(len(inp_filenames), len(out_filenames))

    message = 'Warning: INT2LM input/output mismatch for "%s" with difference %f!'

    for ifn, ofn in zip(inp_filenames, out_filenames):

        print(os.path.basename(ifn), os.path.basename(ofn))

        with Dataset(ifn) as di, Dataset(ofn) as do:

            keys = [key for key in do.variables.keys() if key[:2] in ['CO', 'NO']]

            for key in keys:
                vi = np.sum(di.variables[key][:,:,2:-2,2:-2])
                #vi = np.sum(di.variables[key][:,:])
                vo = np.sum(do.variables[key][:])

                if abs(vi) < 1e-12:
                    d = abs(vo - vi)
                else:
                    d = abs(vo - vi) / vi

                if d > 1e-4:
                    print(message % (key, d))



if __name__ == '__main__':
    main("/project/d73/input/")
